function [ imgDest ] = detect( imgSrc )
%function [ imgDest ] = detect( imgSrc )
%  Detects edges in a bitmap, imgSrc, in the horizontal and
%  vertical directions to produce an output, imgDest.
%
%  ISE1 And EE2 Computing Course
%  MATLAB Assignment: Image Warping
%  Exercise 3 - Edge Detection
%
%  Andy Bennett (andyjpb@ashurst.eu.org), 16/2/2003

% initialise the destination image to improve speed / memory efficiency
imgDest = zeros(size(imgSrc,1) - 1,size(imgSrc,2) - 1);

for y = 1:size(imgSrc,1)-1,
  for x= 1:size(imgSrc,2)-1,
      imgDest(y,x) = abs( imgSrc(y,x) - imgSrc(y, x+1) );
      imgDest(y,x) = imgDest(y,x) + abs( imgSrc(y,x) - imgSrc(y+1, x) );
  end
end

imgDest = imgDest / 2;