function [ imgDest ] = shear( imgSrc, Xshear, Yshear )
%function [ imgDest ] = shear( imgSrc, Xshear, Yshear )
%  Shears a bitmap, imgIn, in the X direction by Xshear and in the
%  Y direction by Yshear, to produce imgOut.
%
%  ISE1 And EE2 Computing Course
%  MATLAB Assignment: Image Warping
%  Exercise 2 - Image Shearing
%
%  Andy Bennett (andyjpb@ashurst.eu.org), 16/2/2003

% set up constants
invtransform = inv([1 Xshear; Yshear 1]);
center = round(size(imgSrc) / 2);

% use some more constants to simplify the expression for the actual transformation
A = invtransform(1,1);
B = invtransform(1,2);
C = invtransform(2,1);
D = invtransform(2,2);
Yc = center(1);
Xc = center(2);

% initialise the destination image to improve speed / memory efficiency
imgDest = zeros(size(imgSrc,1),size(imgSrc,2));

for y = 1:size(imgSrc,1),
  for x= 1:size(imgSrc,2),
    M = round((invtransform)*([x;y] - [Xc; Yc]) + [Xc; Yc])+1;
    if ((M(1) <= size(imgSrc,2)) & (M(1) > 0) & (M(2) <= size(imgSrc,1)) & (M(2) > 0))
      imgDest(y,x) = imgSrc(M(2),M(1));
    else
      imgDest(y,x) = 0;
    end
  end
end
